#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

/**
 * n m type delta
 * type: how many sticks
 * delta: wnext
 * **/

void putQuery(int v, int u) {
    printf("? %i %i\n", v, u);
}


void putEdge(pair<int, int> e) {
    printf("! %i %i\n", e.first, e.second);
}


int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    int n = atoi(argv[1]);
    int m = atoi(argv[2]);
    if (m < n) {
        m = n + 1;
    }
    vector<int> order(n);
    for (int i = 1; i <= n; i++) {
        order[i - 1] = i;
    }
    shuffle(order.begin() + 1, order.end());
    int type = atoi(argv[3]);
    int delta = atoi(argv[4]);
    vector<pair<int, int>> edges;
    vector<vector<int>> sticks(type, {1});
    vector<int> stInd(n + 1);
    for (int i = 1; i < n; i++) {
        int st = rnd.next(type);
        int ind = rnd.wnext(sticks[st].size(), delta);
        edges.push_back(make_pair(sticks[st][ind], order[i]));
        sticks[st].push_back(order[i]);
        stInd[order[i]] = st;
    }
    printf("%i %i\n", n, m);
    m -= n - 1;
    int ql = -m - 100;
    sticks.clear();
    sticks.resize(type, {1});
    for (auto e : edges) {
        ql++;
        putEdge(e);
        int leaf = e.second;
        sticks[stInd[leaf]].push_back(leaf);
        for (int i = 0; i < rnd.wnext(m + 1, ql) and m > 0; i++, m--) {
            int s1 = rnd.next(type), s2 = rnd.next(type);
            int v = sticks[s1][rnd.wnext(sticks[s1].size(), 100)];
            int u = sticks[s2][rnd.wnext(sticks[s2].size(), 100)];
            while (v == u) {
                s1 = rnd.next(type);
                s2 = rnd.next(type);
                v = sticks[s1][rnd.wnext(sticks[s1].size(), 100)];
                u = sticks[s2][rnd.wnext(sticks[s2].size(), 100)];

            }
            putQuery(v, u);
        }
    }
    while (m > 0) {
        int s1 = rnd.next(type), s2 = rnd.next(type);
        int v = sticks[s1][rnd.wnext(sticks[s1].size(), 100)];
        int u = sticks[s2][rnd.wnext(sticks[s2].size(), 100)];
        while (v == u) {
            s1 = rnd.next(type);
            s2 = rnd.next(type);
            v = sticks[s1][rnd.wnext(sticks[s1].size(), 100)];
            u = sticks[s2][rnd.wnext(sticks[s2].size(), 100)];

        }
        putQuery(v, u);
        m--;
    }
}