#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);
    int n = opt<int>("n"), k = opt<int>("k"), in = opt<int>("in");
    double pdown = opt<double>("pdown");

    int dec9 = 1e9;
    int s, t;
    int len = n / (k + 1);

    vector<pair<int, int>> segs;
    for (int i = 0; i < n; i++) {
        if (i % len == 0) {
            s = rnd.next(n, dec9 - in - rnd.next(in / 2) - n), t = s + in;
        }
        if (i % len == len / 2) {
            segs.push_back({rnd.wnext(0, s / 2, -2), rnd.wnext(t, (t + dec9) / 2, 2)});
        } else if (abs(i % len - len / 2) != 2) {
            if (rnd.next(2))
                segs.push_back({rnd.next(s / 2, s), rnd.wnext(t + 1, dec9, -2)});
            else
                segs.push_back({rnd.wnext(0, s - 1, 2), rnd.next(t, (t + dec9) / 2)});
        } else {
            segs.push_back({rnd.next(s, s + 1), rnd.next(t - 1, t)});
        }
    }
    segs[n / 2].first = max(segs[n / 2].first, n / 2 + 1);
    if (segs[n / 2].first >= segs[n / 2].second) {
        segs[n / 2].second = rnd.next(segs[n / 2].first + 1, dec9);
    }
    for (int i = n / 2; i > 0; i--) {
        if (segs[i - 1].first > segs[i].first) {
            segs[i - 1].first = rnd.next(pdown) ? segs[i].first - 1 : segs[i].first;
            segs[i - 1].first = max(segs[i - 1].first, 0);
        }
    }
    for (int i = n / 2; i + 1 < n; i++) {
        if (segs[i + 1].first < segs[i].first) {
            segs[i + 1].first = rnd.next(pdown) ? segs[i].first + 1 : segs[i].first;
            if (segs[i + 1].first >= segs[i + 1].second) {
                segs[i + 1].second = rnd.next(segs[i + 1].first + 1, dec9);
            }
        }
    }

    int length = segs[n / 2].second - segs[n / 2].first;
    println(n, length / 2, min(length * 2, dec9));
    for (auto &p: segs) {
        println(p.first, p.second);
    }

}