#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

/**
 * n m deltaTree(dt) queryLocation(ql) randomQueryDistribution(rqd)
 * dt = -inf - bamboo, +inf - ezh
 * ql - 0: random, -x: mostly in the end
 * rqd: how many ? out of 10000 will be random(can use unadded v or u)
 * **/

void putQuery(int v, int u) {
    printf("? %i %i\n", v, u);
}


void putEdge(pair<int, int> e) {
    printf("! %i %i\n", e.first, e.second);
}


int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    int n = atoi(argv[1]);
    int m = atoi(argv[2]);
    if (m < n) {
        m = n + 1;
    }
    vector<int> order(n);
    for (int i = 1; i <= n; i++) {
        order[i - 1] = i;
    }
    if (n > 1) {
        shuffle(order.begin() + 1, order.end());
    }
    int deltaTree = atoi(argv[3]);
    vector<pair<int, int>> edges;
    for (int i = 1; i < n; i++) {
        int ind = rnd.wnext(i, deltaTree);
        edges.push_back(make_pair(order[ind], order[i]));
    }
    int ql = atoi(argv[4]);
    int rqd = atoi(argv[5]);
    vector<int> good = {1};

    printf("%i %i\n", n, m);
    m -= n - 1;
    if (ql == 0) {
        int meanQ = max(2 * m / n, 1);
        for (auto e : edges) {
            putEdge(e);
            good.push_back(e.second);
            for (int i = 0; i < rnd.next(meanQ) and m > 0; i++, m--) {
                if (rnd.next(1, 10000) <= rqd) {
                    int v = rnd.next(1, n);
                    int u = rnd.next(1, n);
                    while (v == u) {
                        u = rnd.next(1, n);
                    }
                    putQuery(v, u);
                } else {
                    int v = rnd.any(good);
                    int u = rnd.any(good);
                    while (v == u) {
                        u = rnd.any(good);
                    }
                    putQuery(v, u);
                }
            }
        }
        while (m > 0) {
            if (rnd.next(1, 10000) <= rqd) {
                int v = rnd.next(1, n);
                int u = rnd.next(1, n);
                while (v == u) {
                    u = rnd.next(1, n);
                }
                putQuery(v, u);
            } else {
                int v = rnd.any(good);
                int u = rnd.any(good);
                while (v == u) {
                    u = rnd.any(good);
                }
                putQuery(v, u);
            }
            m--;
        }
    } else {
        for (auto e : edges) {
            ql++;
            putEdge(e);
            good.push_back(e.second);
            for (int i = 0; i < rnd.wnext(m + 1, ql) and m > 0; i++, m--) {
                if (rnd.next(1, 10000) <= rqd) {
                    int v = rnd.next(1, n);
                    int u = rnd.next(1, n);
                    while (v == u) {
                        u = rnd.next(1, n);
                    }
                    putQuery(v, u);
                } else {
                    int v = rnd.any(good);
                    int u = rnd.any(good);
                    while (v == u) {
                        u = rnd.any(good);
                    }
                    putQuery(v, u);
                }
            }
        }
        while (m > 0) {
            if (rnd.next(1, 10000) <= rqd) {
                int v = rnd.next(1, n);
                int u = rnd.next(1, n);
                while (v == u) {
                    u = rnd.next(1, n);
                }
                putQuery(v, u);
            } else {
                int v = rnd.any(good);
                int u = rnd.any(good);
                while (v == u) {
                    u = rnd.any(good);
                }
                putQuery(v, u);
            }
            m--;
        }
    }
}